import React, {Component} from 'react'
import { Button } from 'antd'

/**
 * @description 异步加载模块
 * @param {*} importComponent
 */
export default function asyncComponent(importComponent) {
  return class extends Component {
    constructor(props) {
      super(props)

      this.state = {
        component: null
      }
    }

    async componentDidMount() {
      const {default: component} = await importComponent()

      this.setState({component})
    }

    // <Button className="loading-skeleton" disabled={true}></Button> // 骨架按钮
    render() {
      const C = this.state.component
      const btn = this.props.btn || {}
      let style = {}

      if (!C && btn.btnstyle) {
        if (btn.btnstyle.marginRight) {
          style.marginRight = btn.btnstyle.marginRight
        }
        if (btn.btnstyle.marginLeft) {
          style.marginLeft = btn.btnstyle.marginLeft
        }
        if (btn.btnstyle.marginTop) {
          style.marginTop = btn.btnstyle.marginTop
        }
        if (btn.btnstyle.marginBottom) {
          style.marginBottom = btn.btnstyle.marginBottom
        }
      }

      return C ?
        <C {...this.props} /> :
        <Button className={'mk-btn mk-' + btn.class} style={style} icon={btn.icon} disabled={true} >{btn.label}</Button>
    }
  }
}